/*  CUSTOM.E	 8-Aug-88 by Kevin D. Quitt

 4-Mar-87 13:21:52, [KDQ]c:\e\eel\custom.e, Edit 870304132152 by KDQ
    Eliminated some of the originators stuff, expanded the functionality
    of the module
*/

#include "eel.h"
#include    "kdq.h"

/*  Custom stuff for each hacker
*/
command add_modification_history_entry()
   {
    stuff( "\n\n" );			/* Create whitespace	*/
    iter = 2;				/*  then move back up	*/
    up_line();
    insert_daytime();			/* Daytime first	*/
    stuff( ", " );
    stuff( "[MSC]" );			/* Machine specific ID	*/
    stuff(filename);			/* Current file path ID */
    stuff( ", Edit " );
    insert_timestamp();			/* Timestamp ID		*/
    stuff( "by KDQ\n\t" );
   }

command author()
   {
    insert_daytime();
    stuff( " by Kevin D. Quitt" );
   }


command next_number()
   {
    char    buf[ 20 ];
    char    fmt[ 20 ];

    if ( has_arg )
       {
	if ( iter < 0 )
	    sprintf( fmt, "%%0%dd", -iter );
	else
	    sprintf( fmt, "%%%dd", iter );
	sprintf( buf, fmt, number_next++ );
       }
    else
	sprintf( buf, "%d", number_next++ );

    stuff( buf );
    iter    = 0;
   }

command next_hex_number()
   {
    char    buf[ 20 ];
    char    fmt[ 20 ];

    if ( has_arg )
       {
	if ( iter < 0 )
	    sprintf( fmt, "%%0%XX", -iter );
	else
	    sprintf( fmt, "%%%XX", iter );
	sprintf( buf, fmt, number_next++ );
       }
    else
	sprintf( buf, "%X", number_next++ );

    stuff( buf );
    iter    = 0;
   }

command previous_number()
   {
    char    buf[ 20 ];
    char    fmt[ 20 ];

    if ( has_arg )
       {
	if ( iter < 0 )
	    sprintf( fmt, "%%%0%dd", -iter );
	else
	    sprintf( fmt, "%%%dd", iter );
	sprintf( buf, fmt, number_next-- );
       }
    else
	sprintf( buf, "%d", number_next-- );

    stuff( buf );
    iter    = 0;
   }

command previous_hex_number()
   {
    char    buf[ 20 ];
    char    fmt[ 20 ];

    if ( has_arg )
       {
	if ( iter < 0 )
	    sprintf( fmt, "%%%0%XX", -iter );
	else
	    sprintf( fmt, "%%%XX", iter );
	sprintf( buf, fmt, number_next-- );
       }
    else
	sprintf( buf, "%X", number_next-- );

    stuff( buf );
    iter    = 0;
   }

command last_kbd_macro() on reg_tab[FKEY(2)]
   {
    noteput( "Keyboard Macro not defined" );
   }

command set_tab_size()
  {
    tab_size	= iter;
    make_mode();
    build_first = 1;
    iter	= 0;
  }

when_loading()
   {
    load_commands("daytime");		/* Time and date.		    */
    load_commands("direct");		/* Directories.			    */
    load_commands("nametbl");		/* Debugging aids.		    */
/** load_commands("col");		/* Columnar work		    */
    load_commands("diff");		/* diff function		    */
    load_commands("language");		/* Load the static language module */
   }
