/* language.e - Language-specific handling code */

#include "eel.h"
#include    "kdq.h"

command language()
   {
    char idx,name[100];

    get_language(name,"Language: ");
    for (idx = 0; language_info[idx].name; ++idx)
       {
	if ( strcmp( name, language_info[ idx ].name) == 0)
	   {
	    set_language( idx, TRUE );
	    return;
	   }
       }
    say("No language entry '%s'",name);
   }

set_language(idx, mm)
char	idx;
int	mm;				/* 808150941 KDQ    */
   {
    language_mode = idx;
    tab_size = language_info[idx].tab_size;
    if (!(fill_mode = language_info[idx].auto_fill_p))
	margin_right = language_info[idx].comment.col;
    if ( mm )
       {
	make_mode();
	iter = 0;
	build_first = 1;
       }

    delete_hacking_tabs = idx == LANGUAGE_C;
   }

/* Set up default language modes from filename extensions */

suffix_c()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }
suffix_h()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }
suffix_e()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }
suffix_y()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }
suffix_l()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }
suffix_cpp()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }
suffix_hpp()	{ c_mode(); set_language( LANGUAGE_C, TRUE ); }

suffix_pas()	{ set_language( LANGUAGE_PASCAL, TRUE ); }

suffix_plm()	{ set_language( LANGUAGE_PLM, TRUE ); }
suffix_p86()	{ set_language( LANGUAGE_PLM, TRUE ); }

suffix_asm()	{ set_language( LANGUAGE_ASSEMBLY, TRUE ); }
suffix_a86()	{ set_language( LANGUAGE_ASSEMBLY, TRUE ); }
suffix_inc()	{ set_language( LANGUAGE_ASSEMBLY, TRUE ); }
suffix_s()	{ set_language( LANGUAGE_ASSEMBLY, TRUE ); }

suffix_txt()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_doc()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_do()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_mmo()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_now()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_me()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_log()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_hlp()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_man()	{ set_language( LANGUAGE_TEXT, TRUE ); }
suffix_lst()	{ set_language( LANGUAGE_TEXT, TRUE ); }



command make_comment() on reg_tab[ALT(';')]
   {
    if (current_column() < language_info[language_mode].comment.col)
	to_column(language_info[language_mode].comment.col);
    else
	stuff(language_info[language_mode].comment.over);
    stuff(language_info[language_mode].comment.start);
    stuff(language_info[language_mode].comment.end);
    point -= language_info[language_mode].comment.offset;
    iter = 0;	    /* discard argument */
   }


command make_begin_end_pair() on reg_tab[ALT(OPEN_BRACE)]
   {
    char temp;

    if (language_info[language_mode].block.begin[0] == 0) return;

    iter = 0;	    /* discard argument */

    if ( language_mode	==  LANGUAGE_C )
       {
	delete_horizontal_space();
	key = OPEN_BRACE;
	c_open();
	insert( '\n' );
	insert( '\n' );
	temp	    = Matchdelim;
	Matchdelim  = 0;
	key = CLOSE_BRACE;
	c_close();
	Matchdelim  = temp;
	iter	    = 1;
	up_line();
	indent_under();
	do_c_indent();
	return;
       }

    to_end_line();
    temp = current_column();
    if ( temp == 0 )
	to_column( temp = tab_size - outdent );

    stuff(language_info[language_mode].block.begin);
    insert('\n');
    to_column(temp);
    stuff(language_info[language_mode].block.end);
    to_begin_line();
    insert('\n');
    point--;
    indent_previous();
    insert('\t');
   }

command insert_matching() on reg_tab[CLOSE_PAREN],
			     reg_tab[CLOSE_BRACKET],
			     reg_tab[CLOSE_BRACE]
   {
    normal_character();
    if (language_mode  &&  (language_mode !=  LANGUAGE_TEXT))
	find_delimiter();
   }

int l_match_idx;

char *l_match(s, start)
char *s;
   {
    int l;

    if (start & STARTMATCH)
	l_match_idx = 1;		/* 0 is NUL (i.e. not a language)   */

    if (language_info[ l_match_idx ].name[ 0 ]	==  0 )
	return	0;

    if ((l = strlen(s)) == 0)
	return	language_info[ l_match_idx++ ].name;

    for ( ; language_info[ l_match_idx ].name[ 0 ]; l_match_idx++)
       {
	if ( !strncmp(s, language_info[ l_match_idx ].name, l) )
	    return language_info[l_match_idx++].name;
       }
    return 0;
   }


get_language(res, pr)
char *res, *pr;
   {
    comp_read( res, pr, l_match, COMP_FOLD, "nul" );
   }

